package dev.ninjdai.werewolf.uhc.events;

import dev.ninjdai.werewolf.uhc.roles.Role;
import dev.ninjdai.werewolf.uhc.roles.RoleProperties;
import net.kyori.adventure.text.Component;
import net.minestom.server.MinecraftServer;
import net.minestom.server.entity.Entity;
import net.minestom.server.entity.ItemEntity;
import net.minestom.server.entity.Player;
import net.minestom.server.entity.damage.Damage;
import net.minestom.server.instance.Instance;
import net.minestom.server.item.ItemStack;
import net.minestom.server.timer.Task;
import net.minestom.server.timer.TaskSchedule;
import org.jetbrains.annotations.NotNull;

public class TimedPlayerDeath {
    private final ItemStack[] inventory;
    private final Instance instance;
    private final Player targetPlayer;
    private final Task triggerTask;

    public TimedPlayerDeath(@NotNull Player player, @NotNull Damage damage, int seconds) {
        this.inventory = player.getInventory().getItemStacks();
        this.instance = player.getInstance();
        this.targetPlayer = player;

        this.triggerTask = MinecraftServer.getSchedulerManager().scheduleTask(this::trigger, TaskSchedule.seconds(seconds));
    }

    public void cancel() {
        this.triggerTask.cancel();
    }

    private TaskSchedule trigger(){
        for (ItemStack itemStack: inventory) {
            instance.getEntities().add(new ItemEntity(itemStack));
        }

        if ((!this.targetPlayer.getTag(Role.roleTag).isBlank())
                && (!Role.roleMap.get(targetPlayer.getTag(Role.roleTag)).getRoleProperties().contains(RoleProperties.NO_DEATH_MESSAGE))) {
            this.instance.sendMessage(Component.text(targetPlayer.getUsername()).append(Component.text(" died")));
        }

        return TaskSchedule.stop();
    }
}
