package dev.ninjdai.werewolf.uhc.events;

import dev.ninjdai.werewolf.uhc.teams.Team;
import dev.ninjdai.werewolf.uhc.teams.WinCondition;
import io.github.togar2.pvp.events.EntityPreDeathEvent;
import net.minestom.server.MinecraftServer;
import net.minestom.server.entity.GameMode;
import net.minestom.server.entity.Player;
import net.minestom.server.event.EventFilter;
import net.minestom.server.event.EventNode;
import net.minestom.server.event.trait.EntityEvent;

public class UHCPlayerDeathEvent {
    public static void onPlayerDeath(EntityPreDeathEvent event) {
        Player player = (Player) event.getEntity();
        if(event.getDamage().getAttacker() instanceof Player killer && !killer.getTag(Team.teamTag).isBlank()) {
            Team team = Team.teamMap.get(killer.getTag(Team.teamTag));
            WinCondition.checkTeamWin(team, event.getInstance().getPlayers());
        }

        event.setCancelDeath(true);
        player.setGameMode(GameMode.SPECTATOR);

        var timedPlayerDeath = new TimedPlayerDeath(player, event.getDamage(), 15);
    }

    public static void register() {
        EventNode<EntityEvent> playerNode = EventNode.type("player-listener", EventFilter.ENTITY);
        MinecraftServer.getGlobalEventHandler().addChild(playerNode);

        playerNode.addListener(EntityPreDeathEvent.class, event -> {
            if (event.getEntity() instanceof Player) onPlayerDeath(event);
        });
    }
}
